summaryrefslogtreecommitdiffstats
path: root/debian/nfs-common.init
diff options
context:
space:
mode:
Diffstat (limited to 'debian/nfs-common.init')
-rwxr-xr-xdebian/nfs-common.init31
1 files changed, 28 insertions, 3 deletions
diff --git a/debian/nfs-common.init b/debian/nfs-common.init
index eef076d..cd74730 100755
--- a/debian/nfs-common.init
+++ b/debian/nfs-common.init
@@ -19,6 +19,8 @@ DEFAULTFILE=/etc/default/nfs-common
PREFIX=
NEED_LOCKD=
NEED_IDMAPD=yes
+IDMAPD_PIDFILE=/var/run/rpc.idmapd.pid
+PIPEFS_MOUNTPOINT=/var/lib/nfs/rpc_pipefs
if [ -f $DEFAULTFILE ]; then
. $DEFAULTFILE
fi
@@ -50,6 +52,23 @@ esac
[ -x $PREFIX/sbin/rpc.lockd ] || [ "$NEED_LOCKD" = no ] || exit 0
[ -x /usr/sbin/rpc.idmapd ] || [ "$NEED_IDMAPD" = no ] || exit 0
+do_modprobe() {
+ modprobe -q $1 || true
+}
+
+do_mount() {
+ if ! grep -E -qs "$1\$" /proc/filesystems
+ then
+ return 1
+ fi
+ if ! mountpoint -q $2
+ then
+ mount -t $1 $3 $1 $2
+ return
+ fi
+ return 0
+}
+
# See how we were called.
case "$1" in
start)
@@ -66,9 +85,14 @@ case "$1" in
fi
if [ "$NEED_IDMAPD" = yes ]
then
- printf " idmapd"
- start-stop-daemon --start --quiet \
- --exec /usr/sbin/rpc.idmapd
+ do_modprobe nfs
+ if do_mount rpc_pipefs $PIPEFS_MOUNTPOINT;
+ then
+ printf " idmapd"
+ start-stop-daemon --start --quiet \
+ --make-pidfile --pidfile $IDMAPD_PIDFILE \
+ --exec /usr/sbin/rpc.idmapd
+ fi
fi
echo "."
;;
@@ -80,6 +104,7 @@ case "$1" in
printf " idmapd"
start-stop-daemon --stop --oknodo --quiet \
--name rpc.idmapd --user 0
+ rm -f $IDMAPD_PIDFILE
fi
if [ "$NEED_LOCKD" = yes ]
then